
import os
from gtts import gTTS
import re
import shutil
import subprocess
#エンコーディング判定
import chardet

def remove_temp_folders():
    # Remove the "temp_mp3" folder if it exists
    temp_mp3_folder = "temp_mp3"
    if os.path.exists(temp_mp3_folder):
        shutil.rmtree(temp_mp3_folder)
        
    # Remove the "temp_cb_mp3" folder if it exists
    temp_cb_mp3_folder = "temp_cb_mp3"
    if os.path.exists(temp_cb_mp3_folder):
        shutil.rmtree(temp_cb_mp3_folder)


# Call the function to remove the temp folders when the program starts
remove_temp_folders()

def convert_date(date):
    # 正規表現パターンにマッチするか確認
    pattern = r'^(\d{4})[-/](\d{1,2})[-/](\d{1,2})(?:-(\d{1,2}))?$'
    match = re.match(pattern, date)

    if not match:
        return None

    year = int(match.group(1))
    month = int(match.group(2))
    start_day = int(match.group(3))
    end_day = match.group(4)

    # 終了日が指定されている場合は、その値を使用
    if end_day:
        end_day = int(end_day)
    else:
        end_day = start_day

    # 日付範囲の文字列を生成
    if start_day == end_day:
        day_string = f"{start_day}日"
    else:
        day_string = f"{start_day}～{end_day}日"

    # 年月日を指定のフォーマットに変換
    formatted_date = f"{year}年{month}月{day_string}"
    return formatted_date


def main(input_file_path, output_folder):
    filepath = input_file_path

    # Create a directory named "source_data" if it doesn't exist
    if not os.path.exists('source_data'):
        os.mkdir('source_data')
    
    if filepath:

        # Define the file paths inside the "source_data" directory
        copy_file_path = os.path.join('source_data', 'info01.txt')
        info03_file_path = os.path.join('source_data', 'info03.txt')
        info04_file_path = os.path.join('source_data', 'info04.txt')
        info05_file_path = os.path.join('source_data', 'info05.txt')
        info07_file_path = os.path.join('source_data', 'info07.txt')
        data01_file_path = os.path.join('source_data', 'data01.txt')
        data02_file_path = os.path.join('source_data', 'data02.txt')


        with open(filepath, 'rb') as input_file:
            raw_data = input_file.read()
            detected_encoding = chardet.detect(raw_data)['encoding']

            #print("Detected encoding:", detected_encoding)

            print("しばらくお待ちください")
            if detected_encoding == "MacRoman":
                detected_encoding = "shift_JIS"

        with open(input_file_path, 'r', encoding=detected_encoding, errors='ignore') as input_file, open(copy_file_path, 'w', encoding='utf-8') as copy_file:
            copy_file.write(input_file.read())

        # info01.txt読み込み、改行をすべて消去しinfo03.txtへ吐き出す
        with open(copy_file_path, 'r', encoding='utf-8') as info01_file, open(info03_file_path, 'w', encoding='utf-8') as info03_file:
            info03_file.write(info01_file.read().replace('\n', ''))

        # info03.txtを読み込んで、一番最初に見つかる";B["より前の文字列をすべて消去し、data01.txtへ吐き出す
        with open(info03_file_path, 'r', encoding='utf-8') as info03_file, open(data01_file_path, 'w', encoding='utf-8') as data01_file:
            data = info03_file.read()
            start_index = data.find(';B[')
            if start_index != -1:
                data = data[start_index:]
            data01_file.write(data)

        # info03.txtを読み込んで、一番最初に見つかる";B["より後の文字列をすべて消去し、info04.txtへ吐き出す
        with open(info03_file_path, 'r', encoding='utf-8') as info03_file, open(info04_file_path, 'w', encoding='utf-8') as info04_file:
            data = info03_file.read()
            start_index = data.find(';B[')
            if start_index != -1:
                data = data[:start_index]
            info04_file.write(data)

        # info04.txtを読み込んで、すべての"["の後と、すべての"]"の後に改行を挿入しinfo05.txtへ吐き出す
        with open(info04_file_path, 'r', encoding='utf-8') as info04_file, open(info05_file_path, 'w', encoding='utf-8') as info05_file:
            data = info04_file.read()
            data = data.replace('[', '\n[').replace(']', ']\n').replace(';', ';\n')
            info05_file.write(data)

        #【CUI】info05.txtを読み込んで、"PB"と書かれた行を探し、見つかったら"PBの次の行をvalue1に入力する
        with open(info05_file_path, 'r', encoding='utf-8') as info05_file:
            for line in info05_file:
                if line.strip() == 'PB':
                    value1 = next(info05_file).strip().replace('[', '').replace(']', '')
                    break
               

        #【CUI】info05.txtを読み込んで、"PW"と書かれた行を探し、見つかったら"PWの次の行をvalue2に入力する
        with open(info05_file_path, 'r', encoding='utf-8') as info05_file:
            for line in info05_file:
                if line.strip() == 'PW':
                    value2 = next(info05_file).strip().replace('[', '').replace(']', '')                    
                    break

        #【CUI】info05.txtを読み込んで、"DT"と書かれた行を探し、見つかったら"DTの次の行をvalue3に入力する
        with open(info05_file_path, 'r', encoding='utf-8') as info05_file:
            for line in info05_file:
                if line.strip() == 'DT':
                    value3 = convert_date(next(info05_file).strip().replace('[', '').replace(']', ''))
                    break

        #【CUI】info05.txtを読み込んで、"EV"と書かれた行を探し、見つかったら"EVの次の行をvalue4に入力する
        with open(info05_file_path, 'r', encoding='utf-8') as info05_file:
            for line in info05_file:
                if line.strip() == 'EV':
                    value4 = next(info05_file).strip().replace('[', '').replace(']', '')
                    break


        # 「temp_mp3」フォルダを作成
        temp_mp3_folder = "temp_mp3"
        os.makedirs(temp_mp3_folder, exist_ok=True)
        
        # 「temp_cb_mp3」フォルダを作成
        temp_cb_mp3_folder = "temp_cb_mp3"
        os.makedirs(temp_cb_mp3_folder, exist_ok=True)
        
        # 【CUI】テキストボックスの値を取得
        #value1 = textbox1.get("1.0", "end-1c")
        #value2 = textbox2.get("1.0", "end-1c")
        #value3 = textbox3.get("1.0", "end-1c")
        #value4 = textbox4.get("1.0", "end-1c")



        # Define the file paths inside the "source_data" directory
        info07_file_path = os.path.join('source_data', 'info07.txt')
        data01_file_path = os.path.join('source_data', 'data01.txt')
        data02_file_path = os.path.join('source_data', 'data02.txt')

        #【CUI】info07.txtを作成し、条件に応じて書き込む
        with open(info07_file_path, 'w') as info07_file:
            if value1:
                info07_file.write("黒," + value1 + '\n')

            if value2:
                info07_file.write("白," + value2 + '\n')

            if value3:
                info07_file.write(value3 + '\n')

            if value4:
                info07_file.write(value4 + '\n')
                    

        # 入力ファイル名と出力ファイル名
        input_filename = data01_file_path
        output_filename = data02_file_path

        # ファイルを読み込む
        with open(input_filename, "r") as input_file:
            content = input_file.read()

        # ";B["より前の文字列を削除
        index = content.find(";B[")
        if index != -1:
            content = content[index + len(";B["):]

        # 先頭に";B["を追加
        content = "B[" + content

        # 最後の")"を削除
        if content.endswith(")"):
            content = content[:-1]


        # 置換
        content = content.replace("B", "黒")
        content = content.replace("W", "白")

        content = content.replace("[a", ",１の")
        content = content.replace("[b", ",２の")
        content = content.replace("[c", ",３の")
        content = content.replace("[d", ",４の")
        content = content.replace("[e", ",５の")
        content = content.replace("[f", ",６の")
        content = content.replace("[g", ",７の")
        content = content.replace("[h", ",８の")
        content = content.replace("[i", ",９の")
        content = content.replace("[j", ",１０の")
        content = content.replace("[k", ",１１の")
        content = content.replace("[l", ",１２の")
        content = content.replace("[m", ",１３の")
        content = content.replace("[n", ",１４の")
        content = content.replace("[o", ",１５の")
        content = content.replace("[p", ",１６の")
        content = content.replace("[q", ",１７の")
        content = content.replace("[r", ",１８の")
        content = content.replace("[s", ",１９の")
        content = content.replace("a]", "１")
        content = content.replace("b]", "２")
        content = content.replace("c]", "３")
        content = content.replace("d]", "４")
        content = content.replace("e]", "５")
        content = content.replace("f]", "６")
        content = content.replace("g]", "７")
        content = content.replace("h]", "８")
        content = content.replace("i]", "９")
        content = content.replace("j]", "１０")
        content = content.replace("k]", "１１")
        content = content.replace("l]", "１２")
        content = content.replace("m]", "１３")
        content = content.replace("n]", "１４")
        content = content.replace("o]", "１５")
        content = content.replace("p]", "１６")
        content = content.replace("q]", "１７")
        content = content.replace("r]", "１８")
        content = content.replace("s]", "１９")

        content = content.replace(";", "\n")

        # ファイルに書き込む
        with open(output_filename, "w") as output_file:
            output_file.write(content)


        # テキストファイルのパス
        text_file = data02_file_path

        # 保存フォルダのパス

        
        #value1 = textbox1.get("1.0", "end-1c")
        #value2 = textbox2.get("1.0", "end-1c")
        #value3 = textbox3.get("1.0", "end-1c")
        #value4 = textbox4.get("1.0", "end-1c")

        # 「textbox1_value」フォルダを作成
        output_folder = os.path.join(value4 + "_" + value1 + "-" + value2 + "_" + value3)
        os.makedirs(output_folder, exist_ok=True)

        # 「source mp3」フォルダを指定（元のmp3の所在）
        source_folder = os.path.join('source_data', 's_mp3')

        # 「source」フォルダを指定
        source_data_folder = "source_data"

        
        # 「source num」フォルダを指定
        source_num_folder = "source_data/n_mp3"

        # Read info07.txt and create move_000.mp3 file
        with open(info07_file_path, 'r') as info07_file:
            lines = info07_file.readlines()
            text_to_speak = ""
            for line in lines:
                line = line.strip()
                if line:
                    text_to_speak += line + ","

            if text_to_speak:
                output_file = os.path.join(output_folder, "move_000.mp3")
                tts = gTTS(text=text_to_speak, lang="ja")
                tts.save(output_file)
           
        # テキストファイルを読み込み、各行をmp3に変換
        with open(text_file, "r") as file:
            lines = file.readlines()
            for i, line in enumerate(lines):
                line = line.strip()
                    
                if line:
                    # mp3ファイルを探す
                    mp3_file = os.path.join(source_folder, f"{line}.mp3")
                    if os.path.exists(mp3_file):
                        # mp3ファイルが存在する場合はコピーする
                        output_file = os.path.join(output_folder, f"move_{str(i+1).zfill(3)}.mp3")
                        shutil.copyfile(mp3_file, output_file)
                    else:
                        print(f"MP3 file for {line} not found.")
                      
        # output_folder内のmp3ファイルをtemp_mp3フォルダにコピー
        for filename in os.listdir(output_folder):
            if filename.endswith(".mp3"):
                shutil.copyfile(os.path.join(output_folder, filename), os.path.join(temp_mp3_folder, filename))


        # temp_mp3内のmp3ファイルをtemp_cb_mp3フォルダにコピー
        if not os.path.exists(temp_cb_mp3_folder):
            os.makedirs(temp_cb_mp3_folder)

        temp_files = sorted(os.listdir(temp_mp3_folder), key=lambda x: int(x.split("_")[1].split(".")[0]))
        
        for index, temp_file in enumerate(temp_files):
            new_index = index * 3
            new_filename = f"cb_{new_index:04d}.mp3"
            temp_file_path = os.path.join(temp_mp3_folder, temp_file)
            new_file_path = os.path.join(temp_cb_mp3_folder, new_filename)
            shutil.copyfile(temp_file_path, new_file_path)

            
        # mu2.mp3ファイルをtemp_cb_mp3フォルダにコピー
        temp_files = sorted(os.listdir(temp_mp3_folder), key=lambda x: int(x.split("_")[1].split(".")[0]))
        num_temp_files = len(temp_files)

        source_mu2_path = os.path.join(source_data_folder, "mu2.mp3")


        for index in range(num_temp_files):
            new_index = index * 3 + 1
            new_filename = f"cb_{new_index:04d}.mp3"
            new_file_path = os.path.join(temp_cb_mp3_folder, new_filename)
            shutil.copyfile(source_mu2_path, new_file_path)



        # Num_XXX.mp3ファイルをtemp_cb_mp3フォルダにコピー
        if not os.path.exists(temp_cb_mp3_folder):
            os.makedirs(temp_cb_mp3_folder)

        temp_files = sorted(os.listdir(temp_mp3_folder), key=lambda x: int(x.split("_")[1].split(".")[0]))
        num_temp_files = len(temp_files)

        source_num_folder = os.path.join(source_data_folder, "n_mp3")
        source_files = sorted(os.listdir(source_num_folder), key=lambda x: int(x.split("_")[1].split(".")[0]))
        num_source_files = min(len(source_files), num_temp_files - 1)

        for index in range(num_source_files):
            new_index = index * 3 + 2
            new_filename = f"cb_{new_index:04d}.mp3"
            source_file = source_files[index]
            source_file_path = os.path.join(source_num_folder, source_file)
            new_file_path = os.path.join(temp_cb_mp3_folder, new_filename)
            if os.path.exists(source_file_path):
                shutil.copyfile(source_file_path, new_file_path)
            else:
                print(f"WARNING: {source_file} not found in source_data/n_mp3 folder.")




        import subprocess
        # バッチファイルを実行
        #subprocess.run("comb.bat", shell=True, check=True)
        os.system("comb.bat")


        old_file_path = "output.mp3"  # 変更したいファイルのパスを指定
        new_file_name = output_folder + ".mp3"  # 新しいファイル名を指定
        rename_file(old_file_path, new_file_name)

        #【CUI】
        #label5.config(text="作成完了")  # ラベルを更新



def rename_file(old_file_path, new_file_name):
    try:
        # 新しいファイル名のパスを生成
        folder_path = os.path.dirname(old_file_path)
        new_file_path = os.path.join(folder_path, new_file_name)

        # ファイル名を変更
        os.rename(old_file_path, new_file_path)

    except FileNotFoundError:
        print("指定したファイルが見つかりません。")
    except Exception as e:
        print(f"エラーが発生しました: {e}")



if __name__ == "__main__":
    # コマンドラインから入力ファイル名を受け取る
    input_file_path = input("入力ファイル名を入力してください: ")

    # 出力フォルダのパスを指定してください
    output_folder = "output"

    main(input_file_path, output_folder)        


